/* 
 * File:   PIC16F184xx_ADC.h
 * Author: Hiroyuki Yamada
 *
 * Created on 2020/11/12, 18:06
 */

#ifndef PIC16F184XX_ADC_H
#define	PIC16F184XX_ADC_H

#ifdef	__cplusplus
extern "C" {
#endif

#define ADC_BUF_SIZE	8
#define DCDC_CONTROL_MODE 0 // 1: simple comparator, 0: PWM

// 16F18424 12-bit ADC

void ADC_Init(void);

uint16_t ADC_OneShot(uint8_t channel);
void ADC_Start(uint8_t channel);
void ADC_IRQ(void); // Call from general IRQ routine
uint16_t ADC_GetCurrentSum();

void ADC_SetDCDCVRefValue(uint8_t refValue);

#ifdef	__cplusplus
}
#endif

#endif	/* PIC16F184XX_ADC_H */

