/* Microchip Technology Inc. and its subsidiaries.  You may use this software 
 * and any derivatives exclusively with Microchip products. 
 * 
 * THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS".  NO WARRANTIES, WHETHER 
 * EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED 
 * WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A 
 * PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION 
 * WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION. 
 *
 * IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
 * INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
 * WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS 
 * BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE.  TO THE 
 * FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS 
 * IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF 
 * ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.
 *
 * MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE 
 * TERMS. 
 */

/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef XC_HEADER_TEMPLATE_H
#define	XC_HEADER_TEMPLATE_H

#include <xc.h> // include processor files - each processor file is guarded.  

// to determine CPU type, use this macro def
// #define _PIC16F18424_H_

// Capacitance Meter
#define VBIAS_MAX 60 // volt
#define COUNT_CLOCK 32 // MHz
//#define VCC_PER_VREF 20 // (1) 53.2k 4.0/0.2  (0.2V p-p)
#define VCC_PER_VREF 10 // (1) 25.2k 4.0/0.4  (0.4V p-p)
//#define VCC_PER_VREF 4 //(2) 8.4k 4.0/1.0 (1V p-p)
//#define VCC_PER_VREF 2 //(3) 2.8k 4.0/2.0 (2V p-p)
#define RSRC1 100.0 // kohm
#define RSRC2 0.990 // kohm

// DC-DC
#define PWM6_DIV (8000/22/2) // must be less than 1024
#define PWM6_DUTY_MAX ((PWM6_DIV * 80 / 100)*4) // 80% (145)

#define DCDC_FB_R1 91
#define DCDC_FB_R2 3
#define ADC_FS 4096 // 12bit
#define ADC_VREF 4000 // mV

// UART
#define UART_INIT_MESSAGE "DC Bias Capacitor Meter v1.0\r\n(C)2020 H.Yamada\r\n"
#define UART_SEPARATOR ' '

#define CAPACITOR_HARMONICS_AVARANGE 1

// TODO Insert appropriate #include <>

// TODO Insert C++ class definitions if appropriate

// TODO Insert declarations

// Comment a function and leverage automatic documentation with slash star star
/**
	<p><b>Function prototype:</b></p>
  
	<p><b>Summary:</b></p>

	<p><b>Description:</b></p>

	<p><b>Precondition:</b></p>

	<p><b>Parameters:</b></p>

	<p><b>Returns:</b></p>

	<p><b>Example:</b></p>
	<code>
 
	</code>

	<p><b>Remarks:</b></p>
 */
// TODO Insert declarations or function prototypes (right here) to leverage 
// live documentation

#ifdef	__cplusplus
extern "C" {
#endif /* __cplusplus */

	// TODO If C++ is being used, regular C code needs function names to have C 
	// linkage so the functions can be used by the c code. 

#ifdef	__cplusplus
}
#endif /* __cplusplus */

#endif	/* XC_HEADER_TEMPLATE_H */

